diff -r 6b3ac7e864ba source/scriptinterface/ScriptConversions.cpp
--- a/source/scriptinterface/ScriptConversions.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/ScriptConversions.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -139,13 +139,10 @@
 	return rval;
 }
 
-template<> jsval ScriptInterface::ToJSVal<i32>(JSContext* cx, const i32& val)
+template<> jsval ScriptInterface::ToJSVal<i32>(JSContext* UNUSED(cx), const i32& val)
 {
-	if (INT_FITS_IN_JSVAL(val))
-		return INT_TO_JSVAL(val);
-	jsval rval = JSVAL_VOID;
-	JS_NewNumberValue(cx, val, &rval); // ignore return value
-	return rval;
+	cassert(JSVAL_INT_BITS == 32);
+	return INT_TO_JSVAL(val);
 }
 
 template<> jsval ScriptInterface::ToJSVal<u32>(JSContext* cx, const u32& val)
@@ -201,13 +198,11 @@
 	JSObject* obj = JS_NewArrayObject(cx, 0, NULL);
 	if (!obj)
 		return JSVAL_VOID;
-	JS_AddRoot(cx, &obj);
 	for (size_t i = 0; i < val.size(); ++i)
 	{
 		jsval el = ScriptInterface::ToJSVal<T>(cx, val[i]);
 		JS_SetElement(cx, obj, (jsint)i, &el);
 	}
-	JS_RemoveRoot(cx, &obj);
 	return OBJECT_TO_JSVAL(obj);
 }
 
diff -r 6b3ac7e864ba source/scriptinterface/ScriptInterface.cpp
--- a/source/scriptinterface/ScriptInterface.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/ScriptInterface.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -39,6 +39,8 @@
 const int RUNTIME_SIZE = 16 * 1024 * 1024; // TODO: how much memory is needed?
 const int STACK_CHUNK_SIZE = 8192;
 
+#define signbit(x) ((x) < 0.0 ? true : false) // XXX
+
 #if ENABLE_SCRIPT_PROFILING
 #include "js/jsdbgapi.h"
 #endif
@@ -49,7 +51,7 @@
 {
 	ScriptInterface_impl(const char* nativeScopeName, JSContext* cx);
 	~ScriptInterface_impl();
-	void Register(const char* name, JSFastNative fptr, uintN nargs);
+	void Register(const char* name, JSNative fptr, uintN nargs);
 
 	JSRuntime* m_rt; // NULL if m_cx is shared; non-NULL if we own m_cx
 	JSContext* m_cx;
@@ -286,7 +288,7 @@
 		// Threadsafe SpiderMonkey requires that we have a request before doing anything much
 		JS_BeginRequest(m_cx);
 
-		m_glob = JS_NewObject(m_cx, &global_class, NULL, NULL);
+		m_glob = JS_NewGlobalObject(m_cx, &global_class);
 		ok = JS_InitStandardClasses(m_cx, m_glob);
 
 		JS_DefineProperty(m_cx, m_glob, "global", OBJECT_TO_JSVAL(m_glob), NULL, NULL, JSPROP_ENUMERATE | JSPROP_READONLY
@@ -296,10 +298,10 @@
 	m_nativeScope = JS_DefineObject(m_cx, m_glob, nativeScopeName, NULL, NULL, JSPROP_ENUMERATE | JSPROP_READONLY
 			| JSPROP_PERMANENT);
 
-	JS_DefineFunction(m_cx, m_glob, "print", (JSNative)::print,  0, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT | JSFUN_FAST_NATIVE);
-	JS_DefineFunction(m_cx, m_glob, "log",   (JSNative)::logmsg, 1, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT | JSFUN_FAST_NATIVE);
-	JS_DefineFunction(m_cx, m_glob, "warn",  (JSNative)::warn,   1, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT | JSFUN_FAST_NATIVE);
-	JS_DefineFunction(m_cx, m_glob, "error", (JSNative)::error,  1, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT | JSFUN_FAST_NATIVE);
+	JS_DefineFunction(m_cx, m_glob, "print", ::print,  0, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT);
+	JS_DefineFunction(m_cx, m_glob, "log",   ::logmsg, 1, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT);
+	JS_DefineFunction(m_cx, m_glob, "warn",  ::warn,   1, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT);
+	JS_DefineFunction(m_cx, m_glob, "error", ::error,  1, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT);
 }
 
 ScriptInterface_impl::~ScriptInterface_impl()
@@ -312,9 +314,9 @@
 	}
 }
 
-void ScriptInterface_impl::Register(const char* name, JSFastNative fptr, uintN nargs)
+void ScriptInterface_impl::Register(const char* name, JSNative fptr, uintN nargs)
 {
-	JS_DefineFunction(m_cx, m_nativeScope, name, reinterpret_cast<JSNative>(fptr), nargs, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT | JSFUN_FAST_NATIVE);
+	JS_DefineFunction(m_cx, m_nativeScope, name, fptr, nargs, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT);
 }
 
 ScriptInterface::ScriptInterface(const char* nativeScopeName, const char* debugName) :
@@ -361,8 +363,8 @@
 		return;
 	}
 
-	JSFunction* random = JS_DefineFunction(m->m_cx, JSVAL_TO_OBJECT(math), "random", (JSNative)Math_random, 0,
-			JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT | JSFUN_FAST_NATIVE);
+	JSFunction* random = JS_DefineFunction(m->m_cx, JSVAL_TO_OBJECT(math), "random", Math_random, 0,
+			JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT);
 	if (!random)
 	{
 		LOGERROR(L"ReplaceNondeterministicFunctions: failed to replace Math.random");
@@ -372,7 +374,7 @@
 	JS_SetReservedSlot(m->m_cx, JS_GetFunctionObject(random), 0, PRIVATE_TO_JSVAL(&rng));
 }
 
-void ScriptInterface::Register(const char* name, JSFastNative fptr, size_t nargs)
+void ScriptInterface::Register(const char* name, JSNative fptr, size_t nargs)
 {
 	m->Register(name, fptr, (uintN)nargs);
 }
@@ -387,16 +389,6 @@
 	return m->m_rt;
 }
 
-bool ScriptInterface::AddRoot(void* ptr, const char* name)
-{
-	return JS_AddNamedRoot(m->m_cx, ptr, name) ? true : false;
-}
-
-bool ScriptInterface::RemoveRoot(void* ptr)
-{
-	return JS_RemoveRoot(m->m_cx, ptr) ? true : false;
-}
-
 AutoGCRooter* ScriptInterface::ReplaceAutoGCRooter(AutoGCRooter* rooter)
 {
 	debug_assert(m->m_rt); // this class must own the runtime, else the rooter won't work
@@ -494,19 +486,14 @@
 	JSObject* obj;
 	if (!JS_ValueToObject(m->m_cx, val, &obj) || obj == NULL)
 		return false;
-	JS_AddRoot(m->m_cx, &obj);
 
 	// Check that the named function actually exists, to avoid ugly JS error reports
 	// when calling an undefined value
 	JSBool found;
 	if (!JS_HasProperty(m->m_cx, obj, name, &found) || !found)
-	{
-		JS_RemoveRoot(m->m_cx, &obj);
 		return false;
-	}
 
 	JSBool ok = JS_CallFunctionName(m->m_cx, obj, name, (uintN)argc, argv, &ret);
-	JS_RemoveRoot(m->m_cx, &obj);
 
 	return ok ? true : false;
 }
@@ -638,10 +625,8 @@
 	if (!func)
 		return false;
 
-	JS_AddRoot(m->m_cx, &func); // TODO: do we need to root this?
 	jsval scriptRval;
 	JSBool ok = JS_CallFunction(m->m_cx, NULL, func, 0, NULL, &scriptRval);
-	JS_RemoveRoot(m->m_cx, &func);
 
 	return ok ? true : false;
 }
@@ -782,7 +767,7 @@
 {
 public:
 	ValueCloner(ScriptInterface& from, ScriptInterface& to) :
-		cxFrom(from.GetContext()), cxTo(to.GetContext()), m_RooterFrom(from), m_RooterTo(to)
+		scriptInterfaceFrom(from), cxFrom(from.GetContext()), cxTo(to.GetContext()), m_RooterFrom(from), m_RooterTo(to)
 	{
 	}
 
@@ -792,7 +777,7 @@
 		if (!JSVAL_IS_GCTHING(val) || JSVAL_IS_NULL(val))
 			return val;
 
-		std::map<jsval, jsval>::iterator it = m_Mapping.find(val);
+		std::map<void*, jsval>::iterator it = m_Mapping.find(JSVAL_TO_GCTHING(val));
 		if (it != m_Mapping.end())
 			return it->second;
 
@@ -811,8 +796,7 @@
 		if (JSVAL_IS_DOUBLE(val))
 		{
 			jsval rval;
-			CLONE_REQUIRE(JS_NewNumberValue(cxTo, *JSVAL_TO_DOUBLE(val), &rval), L"JS_NewNumberValue");
-			m_Mapping[val] = rval;
+			CLONE_REQUIRE(JS_NewNumberValue(cxTo, JSVAL_TO_DOUBLE(val), &rval), L"JS_NewNumberValue");
 			m_RooterTo.Push(rval);
 			return rval;
 		}
@@ -822,7 +806,7 @@
 			JSString* str = JS_NewUCStringCopyN(cxTo, JS_GetStringChars(JSVAL_TO_STRING(val)), JS_GetStringLength(JSVAL_TO_STRING(val)));
 			CLONE_REQUIRE(str, L"JS_NewUCStringCopyN");
 			jsval rval = STRING_TO_JSVAL(str);
-			m_Mapping[val] = rval;
+			m_Mapping[JSVAL_TO_GCTHING(val)] = rval;
 			m_RooterTo.Push(rval);
 			return rval;
 		}
@@ -843,13 +827,14 @@
 			CLONE_REQUIRE(newObj, L"JS_NewObject");
 		}
 
-		m_Mapping[val] = OBJECT_TO_JSVAL(newObj);
+		m_Mapping[JSVAL_TO_GCTHING(val)] = OBJECT_TO_JSVAL(newObj);
 		m_RooterTo.Push(newObj);
 
 		JSIdArray* ida = JS_Enumerate(cxFrom, JSVAL_TO_OBJECT(val));
 		CLONE_REQUIRE(ida, L"JS_Enumerate");
 
-		IdArrayWrapper idaWrapper(cxFrom, ida);
+		AutoGCRooter idaRooter(scriptInterfaceFrom);
+		idaRooter.Push(ida);
 
 		for (jsint i = 0; i < ida->length; ++i)
 		{
@@ -880,9 +865,10 @@
 		return OBJECT_TO_JSVAL(newObj);
 	}
 
+	ScriptInterface& scriptInterfaceFrom;
 	JSContext* cxFrom;
 	JSContext* cxTo;
-	std::map<jsval, jsval> m_Mapping;
+	std::map<void*, jsval> m_Mapping;
 	AutoGCRooter m_RooterFrom;
 	AutoGCRooter m_RooterTo;
 };
diff -r 6b3ac7e864ba source/scriptinterface/ScriptInterface.h
--- a/source/scriptinterface/ScriptInterface.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/ScriptInterface.h	Thu Nov 04 14:52:01 2010 +0000
@@ -223,9 +223,6 @@
 	 */
 	template<typename T> static jsval ToJSVal(JSContext* cx, T const& val);
 
-	bool AddRoot(void* ptr, const char* name);
-	bool RemoveRoot(void* ptr);
-
 	AutoGCRooter* ReplaceAutoGCRooter(AutoGCRooter* rooter);
 
 	/**
@@ -264,7 +261,7 @@
 	static JSClass* GetClass(JSContext* cx, JSObject* obj);
 	static void* GetPrivate(JSContext* cx, JSObject* obj);
 
-	void Register(const char* name, JSFastNative fptr, size_t nargs);
+	void Register(const char* name, JSNative fptr, size_t nargs);
 	std::auto_ptr<ScriptInterface_impl> m;
 
 // The nasty macro/template bits are split into a separate file so you don't have to look at them
@@ -276,10 +273,10 @@
 	//   void RegisterFunction(const char* functionName);
 	//
 	//   template <R, T0..., TR (*fptr) (void* cbdata, T0...)>
-	//   static JSFastNative call;
+	//   static JSNative call;
 	//
 	//   template <R, T0..., JSClass*, TC, TR (TC:*fptr) (T0...)>
-	//   static JSFastNative callMethod;
+	//   static JSNative callMethod;
 	//
 	//   template <dummy, T0...>
 	//   static size_t nargs();
diff -r 6b3ac7e864ba source/scriptinterface/ScriptTypes.h
--- a/source/scriptinterface/ScriptTypes.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/ScriptTypes.h	Thu Nov 04 14:52:01 2010 +0000
@@ -25,8 +25,10 @@
 #endif
 // (we don't support XP_OS2 or XP_BEOS)
 
-#include "js/jspubtd.h"
-#include "js/jsversion.h"
+//#include "js/jspubtd.h"
+//#include "js/jsversion.h"
+
+#include "js/jsapi.h"
 
 #if JS_VERSION != 185
 #error Your compiler is trying to use an incorrect version of the SpiderMonkey library.
diff -r 6b3ac7e864ba source/scriptinterface/ScriptVal.cpp
--- a/source/scriptinterface/ScriptVal.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/ScriptVal.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -24,25 +24,32 @@
 struct Unrooter
 {
 	Unrooter(JSContext* cx) : cx(cx) { }
-	void operator()(jsval* p) { JS_RemoveRoot(cx, p); delete p; }
+	void operator()(jsval* p) { JS_RemoveValueRoot(cx, p); delete p; }
 	JSContext* cx;
 };
 
 CScriptValRooted::CScriptValRooted(JSContext* cx, jsval val)
 {
 	jsval* p = new jsval(val);
-	JS_AddNamedRoot(cx, p, "CScriptValRooted");
+	JS_AddNamedValueRoot(cx, p, "CScriptValRooted");
 	m_Val = boost::shared_ptr<jsval>(p, Unrooter(cx));
 }
 
 CScriptValRooted::CScriptValRooted(JSContext* cx, CScriptVal val)
 {
 	jsval* p = new jsval(val.get());
-	JS_AddNamedRoot(cx, p, "CScriptValRooted");
+	JS_AddNamedValueRoot(cx, p, "CScriptValRooted");
 	m_Val = boost::shared_ptr<jsval>(p, Unrooter(cx));
 }
 
-jsval CScriptValRooted::get() const
+const jsval& CScriptValRooted::get() const
+{
+	if (!m_Val)
+		return JSVAL_VOID;
+	return *m_Val;
+}
+
+jsval& CScriptValRooted::get()
 {
 	if (!m_Val)
 		return JSVAL_VOID;
diff -r 6b3ac7e864ba source/scriptinterface/ScriptVal.h
--- a/source/scriptinterface/ScriptVal.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/ScriptVal.h	Thu Nov 04 14:52:01 2010 +0000
@@ -29,10 +29,10 @@
 class CScriptVal
 {
 public:
-	CScriptVal() : m_Val(0) { }
+	CScriptVal() : m_Val(JSVAL_VOID) { }
 	CScriptVal(jsval val) : m_Val(val) { }
 
-	jsval get() const { return m_Val; }
+	const jsval& get() const { return m_Val; }
 
 private:
 	jsval m_Val;
@@ -45,7 +45,8 @@
 	CScriptValRooted(JSContext* cx, jsval val);
 	CScriptValRooted(JSContext* cx, CScriptVal val);
 
-	jsval get() const;
+	const jsval& get() const;
+	jsval& get();
 
 	bool undefined() const;
 
diff -r 6b3ac7e864ba source/scriptinterface/tests/test_ScriptConversions.h
--- a/source/scriptinterface/tests/test_ScriptConversions.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/tests/test_ScriptConversions.h	Thu Nov 04 14:52:01 2010 +0000
@@ -34,7 +34,6 @@
 		JSContext* cx = script.GetContext();
 
 		jsval v1 = ScriptInterface::ToJSVal(cx, value);
-		JS_AddRoot(cx, &v1);
 
 		// We want to convert values to strings, but can't just call toSource() on them
 		// since they might not be objects. So just use uneval.
@@ -42,8 +41,6 @@
 		TS_ASSERT(script.CallFunction(OBJECT_TO_JSVAL(JS_GetGlobalObject(cx)), "uneval", CScriptVal(v1), source));
 
 		TS_ASSERT_STR_EQUALS(source, expected);
-
-		JS_RemoveRoot(cx, &v1);
 	}
 
 	template <typename T>
@@ -53,7 +50,6 @@
 		JSContext* cx = script.GetContext();
 
 		jsval v1 = ScriptInterface::ToJSVal(cx, value);
-		JS_AddRoot(cx, &v1);
 
 		std::string source;
 		TS_ASSERT(script.CallFunction(OBJECT_TO_JSVAL(JS_GetGlobalObject(cx)), "uneval", CScriptVal(v1), source));
@@ -64,8 +60,6 @@
 		T v2 = T();
 		TS_ASSERT(ScriptInterface::FromJSVal(script.GetContext(), v1, v2));
 		TS_ASSERT_EQUALS(value, v2);
-
-		JS_RemoveRoot(cx, &v1);
 	}
 
 public:
@@ -132,18 +126,16 @@
 
 		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, 0)));
 
-		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, 1073741822))); // JSVAL_INT_MAX-1
-		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, 1073741823))); // JSVAL_INT_MAX
-		TS_ASSERT(JSVAL_IS_DOUBLE(ScriptInterface::ToJSVal<i32>(cx, 1073741824))); // JSVAL_INT_MAX+1
-		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, -1073741823))); // JSVAL_INT_MIN+1
-		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, -1073741824))); // JSVAL_INT_MIN
-		TS_ASSERT(JSVAL_IS_DOUBLE(ScriptInterface::ToJSVal<i32>(cx, -1073741825))); // JSVAL_INT_MIN-1
+		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, 2147483646))); // JSVAL_INT_MAX-1
+		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, 2147483647))); // JSVAL_INT_MAX
+		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, -2147483647))); // JSVAL_INT_MIN+1
+		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<i32>(cx, -2147483648))); // JSVAL_INT_MIN
 
 		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<u32>(cx, 0)));
 
-		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<u32>(cx, 1073741822))); // JSVAL_INT_MAX-1
-		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<u32>(cx, 1073741823))); // JSVAL_INT_MAX
-		TS_ASSERT(JSVAL_IS_DOUBLE(ScriptInterface::ToJSVal<u32>(cx, 1073741824))); // JSVAL_INT_MAX+1
+		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<u32>(cx, 2147483646))); // JSVAL_INT_MAX-1
+		TS_ASSERT(JSVAL_IS_INT(ScriptInterface::ToJSVal<u32>(cx, 2147483647))); // JSVAL_INT_MAX
+		TS_ASSERT(JSVAL_IS_DOUBLE(ScriptInterface::ToJSVal<u32>(cx, 2147483648))); // JSVAL_INT_MAX+1
 	}
 
 	void test_nonfinite()
diff -r 6b3ac7e864ba source/scriptinterface/tests/test_ScriptInterface.h
--- a/source/scriptinterface/tests/test_ScriptInterface.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/tests/test_ScriptInterface.h	Thu Nov 04 14:52:01 2010 +0000
@@ -136,7 +136,7 @@
 		TS_ASSERT(script.Eval(input.c_str(), val));
 
 		std::string stringified = script.StringifyJSON(val.get());
-		TS_ASSERT_STR_EQUALS(stringified, "{\n  \"x\":1,\n  \"z\":[2,\n    \"3\xE2\x98\xBA\xEF\xBF\xBD\"\n  ],\n  \"y\":true\n}");
+		TS_ASSERT_STR_EQUALS(stringified, "{\n  \"x\": 1,\n  \"z\": [\n    2,\n    \"3\xE2\x98\xBA\xEF\xBF\xBD\"\n  ],\n  \"y\": true\n}");
 
 		val = script.ParseJSON(stringified);
 		TS_ASSERT_WSTR_EQUALS(script.ToString(val.get()), L"({x:1, z:[2, \"3\\u263A\\uFFFD\"], y:true})");
diff -r 6b3ac7e864ba source/simulation2/scripting/EngineScriptConversions.cpp
--- a/source/simulation2/scripting/EngineScriptConversions.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/scripting/EngineScriptConversions.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -37,7 +37,7 @@
 
 	// If this is a scripted component, just return the JS object directly
 	jsval instance = val->GetJSInstance();
-	if (instance)
+	if (!JSVAL_IS_NULL(instance))
 		return instance;
 
 	// Otherwise we need to construct a wrapper object
diff -r 6b3ac7e864ba source/simulation2/scripting/ScriptComponent.cpp
--- a/source/simulation2/scripting/ScriptComponent.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/scripting/ScriptComponent.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -23,30 +23,22 @@
 #include "simulation2/serialization/IDeserializer.h"
 
 CComponentTypeScript::CComponentTypeScript(ScriptInterface& scriptInterface, jsval instance) :
-	m_ScriptInterface(scriptInterface), m_Instance(instance)
+	m_ScriptInterface(scriptInterface), m_Instance(CScriptValRooted(scriptInterface.GetContext(), instance))
 {
-	debug_assert(instance);
-	m_ScriptInterface.AddRoot(&m_Instance, "CComponentTypeScript.m_Instance");
-
 	// Cache the property detection for efficiency
-	m_HasCustomSerialize = m_ScriptInterface.HasProperty(m_Instance, "Serialize");
-}
-
-CComponentTypeScript::~CComponentTypeScript()
-{
-	m_ScriptInterface.RemoveRoot(&m_Instance);
+	m_HasCustomSerialize = m_ScriptInterface.HasProperty(m_Instance.get(), "Serialize");
 }
 
 void CComponentTypeScript::Init(const CSimContext& UNUSED(context), const CParamNode& paramNode, entity_id_t ent)
 {
-	m_ScriptInterface.SetProperty(m_Instance, "entity", (int)ent, true);
-	m_ScriptInterface.SetProperty(m_Instance, "template", paramNode, true);
-	m_ScriptInterface.CallFunctionVoid(m_Instance, "Init");
+	m_ScriptInterface.SetProperty(m_Instance.get(), "entity", (int)ent, true);
+	m_ScriptInterface.SetProperty(m_Instance.get(), "template", paramNode, true);
+	m_ScriptInterface.CallFunctionVoid(m_Instance.get(), "Init");
 }
 
 void CComponentTypeScript::Deinit(const CSimContext& UNUSED(context))
 {
-	m_ScriptInterface.CallFunctionVoid(m_Instance, "Deinit");
+	m_ScriptInterface.CallFunctionVoid(m_Instance.get(), "Deinit");
 }
 
 void CComponentTypeScript::HandleMessage(const CSimContext& UNUSED(context), const CMessage& msg, bool global)
@@ -55,7 +47,7 @@
 
 	CScriptVal msgVal = msg.ToJSValCached(m_ScriptInterface);
 
-	if (!m_ScriptInterface.CallFunctionVoid(m_Instance, name, msgVal))
+	if (!m_ScriptInterface.CallFunctionVoid(m_Instance.get(), name, msgVal))
 		LOGERROR(L"Script message handler %hs failed", name);
 }
 
@@ -66,13 +58,13 @@
 	if (m_HasCustomSerialize)
 	{
 		CScriptValRooted val;
-		if (!m_ScriptInterface.CallFunction(m_Instance, "Serialize", val))
+		if (!m_ScriptInterface.CallFunction(m_Instance.get(), "Serialize", val))
 			LOGERROR(L"Script Serialize call failed");
 		serialize.ScriptVal("object", val);
 	}
 	else
 	{
-		serialize.ScriptVal("object", m_Instance);
+		serialize.ScriptVal("object", m_Instance.get());
 	}
 }
 
@@ -82,8 +74,8 @@
 
 	// Use ScriptObjectAppend so we don't lose the carefully-constructed
 	// prototype/parent of this object
-	deserialize.ScriptObjectAppend("object", m_Instance);
+	deserialize.ScriptObjectAppend("object", m_Instance.get());
 
-	m_ScriptInterface.SetProperty(m_Instance, "entity", (int)ent, true);
-	m_ScriptInterface.SetProperty(m_Instance, "template", paramNode, true);
+	m_ScriptInterface.SetProperty(m_Instance.get(), "entity", (int)ent, true);
+	m_ScriptInterface.SetProperty(m_Instance.get(), "template", paramNode, true);
 }
diff -r 6b3ac7e864ba source/simulation2/scripting/ScriptComponent.h
--- a/source/simulation2/scripting/ScriptComponent.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/scripting/ScriptComponent.h	Thu Nov 04 14:52:01 2010 +0000
@@ -35,9 +35,8 @@
 {
 public:
 	CComponentTypeScript(ScriptInterface& scriptInterface, jsval instance);
-	~CComponentTypeScript();
 
-	jsval GetInstance() const { return m_Instance; }
+	jsval GetInstance() const { return m_Instance.get(); }
 
 	void Init(const CSimContext& context, const CParamNode& paramNode, entity_id_t ent);
 	void Deinit(const CSimContext& context);
@@ -58,7 +57,7 @@
 	R Call(const char* funcname  BOOST_PP_ENUM_TRAILING_BINARY_PARAMS(i, const T, &a)) \
 	{ \
 		R ret; \
-		if (m_ScriptInterface.CallFunction(m_Instance, funcname  BOOST_PP_ENUM_TRAILING_PARAMS(i, a), ret)) \
+		if (m_ScriptInterface.CallFunction(m_Instance.get(), funcname  BOOST_PP_ENUM_TRAILING_PARAMS(i, a), ret)) \
 			return ret; \
 		LOGERROR(L"Error calling component script function %hs", funcname); \
 		return R(); \
@@ -66,7 +65,7 @@
 	BOOST_PP_IF(i, template<, ) BOOST_PP_ENUM_PARAMS(i, typename T) BOOST_PP_IF(i, >, ) \
 	void CallVoid(const char* funcname  BOOST_PP_ENUM_TRAILING_BINARY_PARAMS(i, const T, &a)) \
 	{ \
-		if (m_ScriptInterface.CallFunctionVoid(m_Instance, funcname  BOOST_PP_ENUM_TRAILING_PARAMS(i, a))) \
+		if (m_ScriptInterface.CallFunctionVoid(m_Instance.get(), funcname  BOOST_PP_ENUM_TRAILING_PARAMS(i, a))) \
 			return; \
 		LOGERROR(L"Error calling component script function %hs", funcname); \
 	}
@@ -75,7 +74,7 @@
 
 private:
 	ScriptInterface& m_ScriptInterface;
-	jsval m_Instance;
+	CScriptValRooted m_Instance;
 	bool m_HasCustomSerialize;
 
 	NONCOPYABLE(CComponentTypeScript);
diff -r 6b3ac7e864ba source/simulation2/serialization/BinarySerializer.cpp
--- a/source/simulation2/serialization/BinarySerializer.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/serialization/BinarySerializer.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -32,7 +32,7 @@
 # pragma warning(disable:4800)	// forcing value to bool 'true' or 'false' (performance warning)
 #endif
 
-#include "js/jsobj.h"
+//#include "js/jsobj.h"
 
 #if MSC_VERSION
 # pragma warning(pop)
@@ -100,43 +100,18 @@
 
 		// Find all properties (ordered by insertion time)
 
-		// JS_Enumerate is a bit slow (lots of memory allocation), so do the enumeration manually
-		// (based on the code from JS_Enumerate, using the probably less stable JSObject API):
-		//
-		// Correction: Actually array_enumerate returns an incorrect num_properties so we can't
-		// trust it and have to iterate over all ids before we know how many there are, so
-		// actually this probably isn't any faster than JS_Enumerate. Also it's less compatible
-		// with future JSAPI updates. This probably wasn't a great idea.
-
 		// (Note that we don't do any rooting, because we assume nothing is going to trigger GC.
 		// I'm not absolute certain that's necessarily a valid assumption.)
 
-		jsval iter_state, num_properties;
-		if (!obj->enumerate(cx, JSENUMERATE_INIT, &iter_state, &num_properties))
-			throw PSERROR_Serialize_ScriptError("enumerate INIT failed");
-		debug_assert(JSVAL_IS_INT(num_properties));
-		debug_assert(JSVAL_TO_INT(num_properties) >= 0);
+		JSIdArray* ida = JS_Enumerate(cx, obj);
+		if (!ida)
+			throw PSERROR_Serialize_ScriptError("JS_Enumerate failed");
 
-		std::vector<jsid> ids;
-		ids.reserve(JSVAL_TO_INT(num_properties));
+		m_Serializer.NumberU32_Unbounded("num props", (uint32_t)ida->length);
 
-		while (true)
+		for (jsint i = 0; i < ida->length; ++i)
 		{
-			jsval id;
-			if (!obj->enumerate(cx, JSENUMERATE_NEXT, &iter_state, &id))
-				throw PSERROR_Serialize_ScriptError("enumerate NEXT failed");
-
-			if (JSVAL_IS_NULL(iter_state))
-				break;
-
-			ids.push_back(id);
-		}
-
-		m_Serializer.NumberU32_Unbounded("num props", (uint32_t)ids.size());
-
-		for (size_t i = 0; i < ids.size(); ++i)
-		{
-			jsval id = ids[i];
+			jsid id = ida->vector[i];
 
 			jsval idval, propval;
 
@@ -183,8 +158,7 @@
 		{
 			debug_assert(JSVAL_IS_DOUBLE(val));
 			m_Serializer.NumberU8_Unbounded("type", SCRIPT_TYPE_DOUBLE);
-			jsdouble* dbl = JSVAL_TO_DOUBLE(val);
-			m_Serializer.NumberDouble_Unbounded("value", *dbl);
+			m_Serializer.NumberDouble_Unbounded("value", JSVAL_TO_DOUBLE(val));
 		}
 		break;
 	}
diff -r 6b3ac7e864ba source/simulation2/serialization/StdDeserializer.cpp
--- a/source/simulation2/serialization/StdDeserializer.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/serialization/StdDeserializer.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -46,7 +46,7 @@
 {
 	std::pair<std::map<u32, JSObject*>::iterator, bool> it = m_ScriptBackrefs.insert(std::make_pair((u32)m_ScriptBackrefs.size()+1, obj));
 	debug_assert(it.second);
-	if (!JS_AddRoot(m_ScriptInterface.GetContext(), (void*)&it.first->second))
+	if (!JS_AddObjectRoot(m_ScriptInterface.GetContext(), &it.first->second))
 		throw PSERROR_Deserialize_ScriptError("JS_AddRoot failed");
 }
 
@@ -63,7 +63,7 @@
 	std::map<u32, JSObject*>::iterator it = m_ScriptBackrefs.begin();
 	for (; it != m_ScriptBackrefs.end(); ++it)
 	{
-		if (!JS_RemoveRoot(m_ScriptInterface.GetContext(), (void*)&it->second))
+		if (!JS_RemoveObjectRoot(m_ScriptInterface.GetContext(), &it->second))
 			throw PSERROR_Deserialize_ScriptError("JS_RemoveRoot failed");
 	}
 	m_ScriptBackrefs.clear();
diff -r 6b3ac7e864ba source/simulation2/system/ComponentManager.cpp
--- a/source/simulation2/system/ComponentManager.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/system/ComponentManager.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -100,12 +100,6 @@
 CComponentManager::~CComponentManager()
 {
 	ResetState();
-
-	// Release GC roots
-	std::map<ComponentTypeId, ComponentType>::iterator it = m_ComponentTypesById.begin();
-	for (; it != m_ComponentTypesById.end(); ++it)
-		if (it->second.type == CT_Script)
-			m_ScriptInterface.RemoveRoot(&it->second.ctor);
 }
 
 void CComponentManager::LoadComponentTypes()
@@ -194,10 +188,7 @@
 			}
 		}
 
-		// Clean up the old component type
-		componentManager->m_ScriptInterface.RemoveRoot(&componentManager->m_ComponentTypesById[cid].ctor);
-
-		// Remove its old message subscriptions
+		// Remove the old component type's message subscriptions
 		std::map<MessageTypeId, std::vector<ComponentTypeId> >::iterator it;
 		for (it = componentManager->m_LocalMessageSubscriptions.begin(); it != componentManager->m_LocalMessageSubscriptions.end(); ++it)
 		{
@@ -228,15 +219,19 @@
 	}
 
 	// Construct a new ComponentType, using the wrapper's alloc functions
-	ComponentType ct = { CT_Script, iid, ctWrapper.alloc, ctWrapper.dealloc, cname, schema, ctor.get() };
+	ComponentType ct = {
+		CT_Script,
+		iid,
+		ctWrapper.alloc,
+		ctWrapper.dealloc,
+		cname,
+		schema,
+		CScriptValRooted(componentManager->m_ScriptInterface.GetContext(), ctor)
+	};
 	componentManager->m_ComponentTypesById[cid] = ct;
 
 	componentManager->m_CurrentComponent = cid; // needed by Subscribe
 
-	// Stop the ctor getting GCed
-	componentManager->m_ScriptInterface.AddRoot(&componentManager->m_ComponentTypesById[cid].ctor, "ComponentType ctor");
-	// TODO: check carefully that roots will never get leaked etc
-
 
 	// Find all the ctor prototype's On* methods, and subscribe to the appropriate messages:
 
@@ -285,7 +280,7 @@
 		for (; eit != comps.end(); ++eit)
 		{
 			jsval instance = eit->second->GetJSInstance();
-			if (instance)
+			if (!JSVAL_IS_NULL(instance))
 				componentManager->m_ScriptInterface.SetPrototype(instance, proto.get());
 		}
 	}
@@ -458,7 +453,7 @@
 void CComponentManager::RegisterComponentType(InterfaceId iid, ComponentTypeId cid, AllocFunc alloc, DeallocFunc dealloc,
 		const char* name, const std::string& schema)
 {
-	ComponentType c = { CT_Native, iid, alloc, dealloc, name, schema, 0 };
+	ComponentType c = { CT_Native, iid, alloc, dealloc, name, schema, CScriptValRooted() };
 	m_ComponentTypesById.insert(std::make_pair(cid, c));
 	m_ComponentTypeIdsByName[name] = cid;
 }
@@ -466,7 +461,7 @@
 void CComponentManager::RegisterComponentTypeScriptWrapper(InterfaceId iid, ComponentTypeId cid, AllocFunc alloc,
 		DeallocFunc dealloc, const char* name, const std::string& schema)
 {
-	ComponentType c = { CT_ScriptWrapper, iid, alloc, dealloc, name, schema, 0 };
+	ComponentType c = { CT_ScriptWrapper, iid, alloc, dealloc, name, schema, CScriptValRooted() };
 	m_ComponentTypesById.insert(std::make_pair(cid, c));
 	m_ComponentTypeIdsByName[name] = cid;
 	// TODO: merge with RegisterComponentType
@@ -584,11 +579,11 @@
 	std::map<entity_id_t, IComponent*>& emap2 = m_ComponentsByTypeId[cid];
 
 	// If this is a scripted component, construct the appropriate JS object first
-	jsval obj = 0;
+	jsval obj = JSVAL_NULL;
 	if (ct.type == CT_Script)
 	{
-		obj = m_ScriptInterface.CallConstructor(ct.ctor);
-		if (!obj)
+		obj = m_ScriptInterface.CallConstructor(ct.ctor.get());
+		if (JSVAL_IS_VOID(obj))
 		{
 			LOGERROR(L"Script component constructor failed");
 			return NULL;
diff -r 6b3ac7e864ba source/simulation2/system/ComponentManager.h
--- a/source/simulation2/system/ComponentManager.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/system/ComponentManager.h	Thu Nov 04 14:52:01 2010 +0000
@@ -66,7 +66,7 @@
 		DeallocFunc dealloc;
 		std::string name;
 		std::string schema; // RelaxNG fragment
-		jsval ctor; // only valid if type == CT_Script
+		CScriptValRooted ctor; // only valid if type == CT_Script
 	};
 
 public:
diff -r 6b3ac7e864ba source/simulation2/system/IComponent.cpp
--- a/source/simulation2/system/IComponent.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/simulation2/system/IComponent.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -40,5 +40,5 @@
 
 jsval IComponent::GetJSInstance() const
 {
-	return 0;
+	return JSVAL_NULL;
 }
